;;;; match-action.scm
;;;; Kon Lovett, Jul '06

(cond-expand [hygienic-macros

(require-extension matchable)

(define-syntax match/action
  (syntax-rules ()
    [(_ ON-SUCCESS ON-FAIL EXPR CLAUSE ...)
      (if (ma$prfm #f (lambda () (match EXPR CLAUSE ...)))
        ON-SUCCESS
        ON-FAIL)] ) )

][else

(require-extension match)

(define-macro (match/action ON-SUCCESS ON-FAIL EXPR . CLAUSES)
  (let ([OLD-STATE (gensym)])
    `(let ([,OLD-STATE (ma$toggle)])
    	(if (ma$prfm ,OLD-STATE (lambda () (match ,EXPR ,@CLAUSES)))
				,ON-SUCCESS
				,ON-FAIL) ) ) )
])
